grammar Language4;







expression : exp
           ;

exp : begin | var | nexp
    ;

begin : '(' 'begin' exp+ ')'
      ;

var : '(' 'var' VARIABLE exp ')'
    ;

nexp : aexp | bexp
     | VARIABLE | INTEGER | BOOLEAN
     ;

aexp : '(' binOp nexp nexp ')'
     | '(' '-' nexp nexp? ')'
     ;

binOp : '+' | '*' | '/' | '%' | '^'
      ;

bexp : '(' boolOp nexp nexp ')'
     | '(' '!' nexp ')'
     | '(' relOp nexp nexp ')'
     | '(' eqOp  nexp nexp ')'
     ;

boolOp : '&&' | '||'
       ;

relOp : '<' | '>' | '<=' | '>='
      ;

eqOp : '==' | '!='
     ;

INTEGER : '0'..'9'+
        ;

BOOLEAN : 'false' | 'true'
        ;

VARIABLE : ('a'..'z'|'A'..'Z')+
         ;

WS : (' '|'\t'|'\n'|'\r')+ {skip();}
   ;
